package javax.robotics.j3d;

/*
 * Axes.java -
 * Copyright (c) 2005 Carmine Lia
 * e-mail:      carmine.lia@libero.it
 * web-address: http://www.intermedia.sa.it/lia

 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

import java.awt.Font;

import javax.media.j3d.*;
import javax.vecmath.*;

import com.sun.j3d.utils.geometry.Text2D;


/**
 * Java3D utility class to draw the axes of cartesian space.
 * <p>the X axis is red.</p>
 * <p>the Y axis is green.</p>
 * <p>the Z axis is blue.</p>
 */
public class Axes extends BranchGroup
{
	
	////////////////////////////////////////////
	//
	// create axis visual object
	//
	/**
	 * Default constructor with axes length 1.
     * The name of the axexs are not showed.
	 */
	public Axes()
	{
       this(1.0f, false);
  	}
	/**
     * Constructor with axes length.
	 * @param a the axes length.
	 * @param showName if true the name of the axes are showed
	 */
	public Axes(float a, boolean showName)
	{
        super();
        addChild(new Axis(a));
        if(showName)
            addChild(getAxesName(a));
        setCollidable(false);
    }
    
    private BranchGroup getAxesName(float a)
    {
        final BranchGroup axesName = new BranchGroup();
        final Transform3D translate = new Transform3D();
        // aggiunta dei nomi degli assi
        final Text2D asseX = new Text2D("X", ColorConstants.RED, "Helvetica", 18,
                Font.BOLD);
       
        translate.set(new Vector3f(a, .050f, -0.0f));
        final TransformGroup tgTextX = new TransformGroup(translate);
        axesName.addChild(tgTextX);
        tgTextX.addChild(asseX);

        final Text2D asseY = new Text2D("Y", ColorConstants.GREEN, "Helvetica", 18,
                Font.BOLD);
        translate.set(new Vector3f(-.05f, a, -0.0f));
        final TransformGroup tgTextY = new TransformGroup(translate);
        axesName.addChild(tgTextY);
        tgTextY.addChild(asseY);

        final Text2D asseZ = new Text2D("Z", ColorConstants.BLUE, "Hevetica", 18,
                Font.BOLD);
        translate.set(new Vector3f(-0.05f, 0.0f, a));
        final TransformGroup tgTextZ = new TransformGroup(translate);
        axesName.addChild(tgTextZ);
        tgTextZ.addChild(asseZ);
        return axesName;
 	}


} 