/*
 * PlaySimulation.java -
 * Copyright (c) 2005 Carmine Lia
 * e-mail:      carmine.lia@libero.it
 * web-address: http://www.intermedia.sa.it/lia

 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
package javax.robotics.simulator;

import java.util.TimerTask;

import javax.robotics.engine.robots.Robot3D;


/**
 * @author carmine lia
 * @version 01/nov/06
 *
 */
final class PlaySimulation extends TimerTask
{
    private int index = 0;
    private final Robot3D robot;
    private final double jointData[][];
    private final int deltaTimer;
    
    /**
     * 
     */
    public PlaySimulation(Robot3D robot, double jointData[][], int deltaTimer)
    {
        super();
        this.robot = robot;
        this.jointData = jointData;
        this.deltaTimer = deltaTimer;
 
    }

    
    /**
     * Main processing method for the SimulationStep object
     */
    public void run()
    {
        index += deltaTimer;

        if(index > jointData.length - 1)
        {
            index = jointData.length - 1;
            robot.setQ3DOnly(jointData[index]);
            this.cancel();
        }
        else
            robot.setQ3DOnly(jointData[index]);

    }
}
